% m_to_y.pl:  translate from M sentences to Y sentences.
% Our job here is to define rules for
% all the predicates exported from y.pl, in
% terms of the rules in m.pl.

% 2014-04-18 : YM : added y/m prefix to each (exported) predicate
% 2014-04-17 : YM : added Y goals

% First, assert the existence of appropriate individuals
% (here, only one: the table).

individuals :-
	abolish(y_this_table/1),
    gensym('y',T),
	assertz(y_this_table(T)).

% y_isTableHeader/3
% y_isTableHeader(Table, Rownum, Colnum)
y_isTableHeader(Table0,Row,Col) :-
    m_this_table(Table1), 
	y_this_table(Table0),
	m_headingcell(Cell),
	table_cell_rownum(Table1, Cell, Row),
	table_cell_colnum(Table1, Cell, Col).

% y_tableCellContent/4
% y_tableCellContent(Table, Row, Column, String)
y_tableCellContent(Table0, Row, Col, String) :-
	m_this_table(Table1), 
	y_this_table(Table0),
	m_cell(Cell),
	table_cell_rownum(Table1, Cell, Row),
	table_cell_colnum(Table1, Cell, Col),
	m_cell_text(Cell, String).

table_cell_rownum(Table,Cell,Rownum) :-
	m_this_table(Table),
	m_row(Row),
	m_table_rowsequence(Table,Rows),
	nth1(Rownum,Rows,Row),
	m_cell(Cell),
	m_row_cellsequence(Row,Cs),
	member(Cell,Cs).

table_cell_colnum(Table, Cell, Colnum) :-
	m_this_table(Table),
	m_column(Column),
	m_table_colsequence(Table,Columns),
	nth1(Colnum,Columns,Column),
	m_cell(Cell),
	m_col_cellsequence(Column, Cells),
	member(Cell, Cells).


obligations :-
	y_this_table(Ty),

	y_isTableHeader(Ty, 1, 1),
	y_isTableHeader(Ty, 1, 2),

	y_tableCellContent(Ty, 1, 1, "Anne"),
	y_tableCellContent(Ty, 1, 2, "vnement"),

	y_tableCellContent(Ty, 2, 1, "1969"),
	y_tableCellContent(Ty, 3, 1, "1992"),

	y_tableCellContent(Ty, 2, 2, "Cration d'ARPANET, le premier rseau national amricain d'ordinateurs, par le Defense Department's Advanced Research Projects Agency (DARPA)"),
	y_tableCellContent(Ty, 3, 2, "Mise en service du World Wide Web par le CERN (Centre europen de recherche nuclaire), en Suisse").
